<template>
  <div>
    <div>
      Listing des nonogrammes
      <ul>
        <li
          v-for="(picross, index) in picrossListing"
          :key="'picross-' + index"
          style="cursor: pointer"
          @click="selectPicross(picross)"
          :data-title="picross.title"
        >
          {{ picross.title }}
        </li>
      </ul>
    </div>

    <picross-player
      v-if="picrossSelected"
      :picross-data="picrossSelected"
      @victory="stopTimer();displayVictory = true"
    />

    Time: {{ currentTime }} s

    <h1
      v-if="displayVictory"
    >
      Victoire !!!
    </h1>

  </div>
</template>

<script>
// @ is an alias to /src
import PicrossPlayer from '../components/PicrossPlayer.vue'
import VueRouter from 'vue-router'

export default {
  name: 'Game',
  components: {
    'picross-player': PicrossPlayer
  },
  data () {
    return {
      picrossListing: [],
      picrossSelected: null,
      displayVictory: false,
      intervalId: null,
      currentTime: 0
    }
  },
  methods: {
    loadDataPicross () {
      fetch('/data/picross.json')
        .then(response => {
          console.log('in first then')
          return response.json()
        })
        .then(picrossArray => {
          console.log('in second then')
          this.picrossListing = picrossArray
          const picross = this.$route?.query?.picross
          if (!picross) return
          const picrossFound = this.picrossListing.find(p => p.title === picross)
          if (picrossFound) this.selectPicross(picrossFound)
        })
    },
    selectPicross (picross) {
      this.$router.push({
        path: '/game',
        query: {
          picross: picross.title
        }
      }).catch(failure => {
        if (VueRouter.isNavigationFailure(failure, VueRouter.NavigationFailureType.duplicated)) {
          // do nothing... maybe a small console...
          console.log('route duplicated...')
        } else return failure
      })
      this.stopTimer()
      this.picrossSelected = picross
      this.displayVictory = false
      this.startTimer()
    },
    resetTime () {
      this.currentTime = 0
    },
    startTimer () {
      this.resetTime()
      this.intervalId = setInterval(() => {
        this.currentTime++
      }, 1000)
    },
    stopTimer () {
      if (this.intervalId) clearInterval(this.intervalId)
    }
  },
  mounted () {
    this.loadDataPicross()
  },
  beforeDestroy () {
    this.stopTimer()
  }
}
</script>

<style scoped>
h1 {
  position: absolute;
  width: 40rem;
  font-size: 5rem;
  top: 10rem;
  padding: 2rem;
  left: calc(50% - 21rem);
  background-color: whitesmoke;
  text-align: center;
}
</style>
